include:
  - template: Security/SAST.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: Security/SAST-IaC.latest.gitlab-ci.yml
  - component: ${CI_SERVER_FQDN}/gitlab-org/components/danger-review/danger-review@1.4.1

stages:
  - cube
  - test
  - build
  - e2e-test

image: docker:24.0.7-dind

services:
  - docker:24.0.7-dind

variables:
  DOCKER_TLS_CERTDIR: ""

schema_specs:
  stage: cube
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
  tags:
    - saas-linux-small-amd64
  script:
    - cp cube/.env.ci cube/.env
    - apk add --no-cache docker-compose
    - apk add --no-cache ruby
    - gem install bundler
    - echo "$ANALYTICS_REGISTRY_PASS" | docker login $ANALYTICS_REGISTRY_HOST -u $ANALYTICS_REGISTRY_USER --password-stdin
    - docker-compose -f docker-compose.ci.yml up -d
    - docker-compose -f docker-compose.ci.yml run specs
build_analytics_gdk:
  stage: build
  tags:
    - saas-linux-medium-amd64
  script:
    - echo "$CI_REGISTRY_PASSWORD" | docker login "$CI_REGISTRY" -u "$CI_REGISTRY_USER" --password-stdin
    - docker_images/e2e_gdk/build_image
e2e_tests:
  stage: e2e-test
  variables:
    # GITLAB_QA_IMAGE is overriden by gitlab-org/gitlab pipeline when devkit CI is used as downstream pipeline.
    GITLAB_QA_IMAGE: registry.gitlab.com/gitlab-org/gitlab/gitlab-ee-qa:master
  tags:
    - saas-linux-medium-amd64
  before_script:
    # Have to export this variable as '${UPSTREAM_COMMIT_SHA:-${CI_COMMIT_SHA}}' script is not supported in variables section
    - export CUSTOM_GDK_IMAGE=${CI_REGISTRY_IMAGE}/analytics-gdk:${UPSTREAM_COMMIT_SHA:-${CI_COMMIT_SHA}}
  script:
    - cp cube/.env.sample cube/.env
    - sed -i "s/GITLAB_BASE_URI=.*/GITLAB_BASE_URI=http\:\/\/gdk\.test\:3000/" cube/.env
    - apk add --no-cache docker-compose
    - echo "$CI_REGISTRY_PASSWORD" | docker login "$CI_REGISTRY" -u "$CI_REGISTRY_USER" --password-stdin
    - echo "CUSTOM GDK IMAGE:" ${CUSTOM_GDK_IMAGE} && echo "QA IMAGE:" ${GITLAB_QA_IMAGE}
    - docker-compose -f docker-compose.e2e.yml run gitlab-qa
  after_script:
    - CONTAINER_ID=$(docker ps -a | grep gitlab-ee-qa | awk '{print $1}')
    - docker cp $CONTAINER_ID:/home/gitlab/qa/tmp/ $CI_PROJECT_DIR/artifacts/
    - docker-compose -f docker-compose.e2e.yml logs > $CI_PROJECT_DIR/artifacts/docker-compose.log
  artifacts:
    when: always
    paths:
      - artifacts/
    expire_in: 1 week
workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: $CI_PIPELINE_SOURCE == "pipeline"
